//+------------------------------------------------------------------+
//|                                           Support&Resistance.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1 

//---- input parameters

extern int Shift=5;

//---- buffers
double BufferUP[];
double BufferDN[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 158);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,BufferUP);
   SetIndexLabel(0,"UP");
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 158);
   SetIndexDrawBegin(1,0);
   SetIndexBuffer(1,BufferDN);
   SetIndexLabel(1,"DN");

   
   return(0); }//int init() 
//+------------------------------------------------------------------+
int start() {
   int limit;
   int iPeriod;
   int counted_bars=IndicatorCounted();
   int i;
   double   y=0,SS=0;
   double tmp1,tmp2,tmp3, Value;   
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//   if (limit>Limit && Limit>0) limit = Limit;
//---- macd counted in the 1-st buffer
   for (i = limit;i>=0;i--){
      BufferUP[i]=BufferUP[i+1];
      BufferDN[i]=BufferDN[i+1];

      tmp1=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_HIGH,0+i);
      tmp2=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_HIGH,1+i);
      tmp3=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_HIGH,2+i);
      if (tmp1<tmp2 && tmp2>=tmp3) BufferUP[i]=High[iHighest(NULL,0,MODE_HIGH,Shift,i)];

      tmp1=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_LOW,0+i);
      tmp2=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_LOW,1+i);
      tmp3=iMA(NULL,0,Shift,0,MODE_SMA,PRICE_LOW,2+i);
      if (tmp1>tmp2 && tmp2<=tmp3) BufferDN[i]=Low[iLowest(NULL,0,MODE_LOW,Shift,i)];      
   }   
   return(0); }// int start()
   //+------------------------------------------------------------------+
   